#line 1 "C:/Users/olu/Desktop/Microcontrollers/PRACTICE/ALL_NEW/I2C/I2C_RTC.c"
#line 11 "C:/Users/olu/Desktop/Microcontrollers/PRACTICE/ALL_NEW/I2C/I2C_RTC.c"
sbit LCD_RS at RD2_bit;
sbit LCD_EN at RD3_bit;
sbit LCD_D7 at RD7_bit;
sbit LCD_D6 at RD6_bit;
sbit LCD_D5 at RD5_bit;
sbit LCD_D4 at RD4_bit;
sbit LCD_RS_Direction at TRISD2_bit;
sbit LCD_EN_Direction at TRISD3_bit;
sbit LCD_D7_Direction at TRISD7_bit;
sbit LCD_D6_Direction at TRISD6_bit;
sbit LCD_D5_Direction at TRISD5_bit;
sbit LCD_D4_Direction at TRISD4_bit;

void main()
{

char tnum0[5], tnum1[5], tnum2[5], tnum3[5], tnum4[5], tnum5[5], tnum6[5], tnum7[5];
int seconds, minutes, hours, dayoftheweek, dateofthemonth, month, year;
int *secondss, *minutess, *hourss, *dayoftheweekk, *dateofthemonthh, *monthh, *yearr;



*secondss= seconds ;
*minutess= minutes ;
*hourss= hours;
*dayoftheweekk= dayoftheweek;
*dateofthemonthh= dateofthemonth;
*monthh= month ;
*yearr= year;


ADCON0 = 0;
ADCON1 = 0xFF;
TRISB = 0;
PORTB = 0;
PORTD = 0xFF;
Lcd_Init();
Lcd_Cmd(_LCD_CURSOR_OFF);
I2C1_Init(100000);
Lcd_Out(1,5, "Init Calendar");
Delay_ms(100);
#line 71 "C:/Users/olu/Desktop/Microcontrollers/PRACTICE/ALL_NEW/I2C/I2C_RTC.c"
 Lcd_Cmd(_LCD_CLEAR);
while(1)
{

I2C1_Start();
I2C1_Wr(0xD0);
I2C1_Wr(0x00);
I2C1_Repeated_Start();
I2C1_Wr(0xD1);


seconds=Bcd2Dec(I2C1_Rd(1));
IntToStr(seconds,tnum0);
ltrim(tnum0);
if(seconds==0)
 {
 Lcd_Cmd(_LCD_CLEAR);
 }


minutes=Bcd2Dec(I2C1_Rd(1) & 0x7F);
IntToStr(minutes,tnum1);
ltrim(tnum1);


hours=Bcd2Dec(I2C1_Rd(1) & 0x3F);
IntToStr(hours,tnum2);
ltrim(tnum2);

dayoftheweek=Bcd2Dec(I2C1_Rd(1) & 0x7F);
IntToStr(dayoftheweek,tnum3);
ltrim(tnum3);

dateofthemonth=Bcd2Dec(I2C1_Rd(1) & 0x3F);
IntToStr(dateofthemonth,tnum4);
ltrim(tnum4);


month=Bcd2Dec(I2C1_Rd(1) & 0x1F);
IntToStr(month,tnum5);
ltrim(tnum5);


year=Bcd2Dec(I2C1_Rd(0));
IntToStr(year,tnum6);
ltrim(tnum6);



 Lcd_Out(1,6, tnum2);
 Lcd_Out_Cp(" : " );
 Lcd_Out_Cp(tnum1);
 Lcd_Out_Cp(" : ");
 Lcd_Out_Cp(tnum0);
Lcd_Cmd(_LCD_THIRD_ROW);



switch (dayoftheweek)
{
case 1: Lcd_Out_Cp("Sun ");
break;
case 2: Lcd_Out_Cp("Mon ");
break;
case 3: Lcd_Out_Cp("Tue ");
break;
case 4: Lcd_Out_Cp("Wed ");
break;
case 5: Lcd_Out_Cp("Thu ");
break;
case 6: Lcd_Out_Cp("Fri ");
break;
case 7: Lcd_Out_Cp("Sat ");
break;
}


if (dateofthemonth==1 || dateofthemonth==21 || dateofthemonth==31)
{
Lcd_Out_Cp(tnum4);
Lcd_Out_Cp("st of ");
}
else if (dateofthemonth==2 || dateofthemonth==22)
{
Lcd_Out_Cp(tnum4);
Lcd_Out_Cp("nd of ");
}
 else if (dateofthemonth==3 || dateofthemonth==23)
{
Lcd_Out_Cp(tnum4);
Lcd_Out_Cp("rd of ");
}
else
{
Lcd_Out_Cp(tnum4);
Lcd_Out_Cp("th of ");
}



switch (month)
{
case 1:Lcd_Out_Cp("Jan ");
break;
case 2:Lcd_Out_Cp("Feb ");
break;
case 3:Lcd_Out_Cp("Mar ");
break;
case 4:Lcd_Out_Cp("Apr ");
break;
case 5:Lcd_Out_Cp("May ");
break;
case 6:Lcd_Out_Cp("Jun ");
break;
case 7:Lcd_Out_Cp("Jul ");
break;
case 8:Lcd_Out_Cp("Aug ");
break;
case 9:Lcd_Out_Cp("Sept. ");
break;
case 10:Lcd_Out_Cp("Oct ");
break;
case 11:Lcd_Out_Cp("Nov ");
break;
case 12:Lcd_Out_Cp("Dec ");
break;
}



Lcd_Out_Cp("20");
Lcd_Out_Cp(tnum6);
I2C1_Stop();
seconds=(seconds & 0x7F);



 I2C1_Start();
 I2C1_Wr(0xD0);
 I2C1_Wr(0x00);
 I2C1_Repeated_Start();
 I2C1_Wr(0xD1);
 *secondss=I2C1_Rd(1);
 *minutess=Bcd2Dec(I2C1_Rd(1) & 0x7F);
 *hourss=Bcd2Dec(I2C1_Rd(1) & 0x3F);
 *dayoftheweekk=Bcd2Dec(I2C1_Rd(1) & 0x7F);
 *dateofthemonthh=Bcd2Dec(I2C1_Rd(1) & 0x3F);
 *monthh=Bcd2Dec(I2C1_Rd(1) & 0x1F);
 *yearr=Bcd2Dec(I2C1_Rd(0));
 I2C1_Stop();


 }

}
